import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.imageio.ImageIO;
import java.net.URL;
import java.awt.Image;
import java.awt.Graphics;

public class PO extends JFrame {
  public static void main( String args[] ) {
    JFrame frame = new PO();
    frame.setSize( 800, 400 );
    frame.setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
    frame.setTitle( "PO Java, Ingrid en Jimi" );
    frame.setContentPane( new POpaneel() );
    frame.setVisible( true );
  }
}

class POpaneel extends JPanel {
  private Verkeerslicht model;
  private JPanel view;
  private JPanel bedieningspaneel;

  public POpaneel() {
    setLayout( new BorderLayout() );
    model = new Verkeerslicht( false, false, true );
    view = new Verkeerslichtview( model );
    bedieningspaneel = new Bedieningspaneel( model, view );
    add( view, BorderLayout.CENTER );
    add( bedieningspaneel, BorderLayout.SOUTH );
  }
}

class Verkeerslichtview extends JPanel {
  private Verkeerslicht model;
  static int x=732;
  static int xi=737;
  static int x2=0;
  static int x2i=-5;
  static int size=100;
  public Image carimage, carimagei, carimage2, carimage2i, backgroundImage;
  public static ImageIcon animatedGif, vliegtuig;
  public static Image grass;
  static double aantal = 1;

  public Verkeerslichtview( Verkeerslicht model ) {
    this.model = model;
    
    setBackground( Color.GREEN );

    animatedGif = new ImageIcon( "12.gif" );
    vliegtuig = new ImageIcon( "vliegtuig.gif" );
    
    try{
      this.carimage = ImageIO.read(new URL("http://www.xs4all.nl/~jomajiti/car.gif"));
      this.carimagei = ImageIO.read(new URL("http://www.xs4all.nl/~jomajiti/cari.gif"));
      this.carimage2 = ImageIO.read(new URL("http://www.xs4all.nl/~jomajiti/car2.gif"));
      this.carimage2i = ImageIO.read(new URL("http://www.xs4all.nl/~jomajiti/car2i.gif"));
      this.backgroundImage = ImageIO.read(new URL("http://www.xs4all.nl/~jomajiti/background.gif"));
      this.grass = ImageIO.read(new URL("http://www.xs4all.nl/~jomajiti/grass.gif"));
    }
    catch(Exception e){
      throw new RuntimeException(e);
    }
  }
    
  public void paintComponent( Graphics g ) {
    super.paintComponent( g );
    int stoplichtMidden = 150;
    int houseNumber = (820/size)+2;

	 g.drawImage(backgroundImage,0,0,null);
	 
	 vliegtuig.paintIcon( this, g, 0, 30 );
	 
    //Weg
    g.setColor( Color.DARK_GRAY );
    g.fillRect( 0, 250, 800, 80);
    for( int i=0; i<14; i++ ){
      g.setColor( Color.WHITE );
      g.fillRect( (60*i)+10, 285, 50, 10 );
    }
    
    //House
    for( int i=0; i<houseNumber; i++ ){
	    g.setColor( Color.YELLOW );
	    g.fillRect( (i*(size-(size/4)))+(i*10)+10, 250-size, size-(size/4), size );
	    Polygon dak = new Polygon();
	    dak.addPoint( (i*(size-(size/4)))+(i*10)+10, 250-size );
	    dak.addPoint( (i*(size-(size/4)))+(i*10)+10+((size-(size/4))/2), 250-(size+(size/3)) );
	    dak.addPoint( (i*(size-(size/4)))+(i*10)+10+(size-(size/4)), 250-size );
	    g.setColor( Color.RED );
	    g.fillPolygon( dak );
	    g.setColor( Color.BLUE );
	    g.fillRect( (i*(size-(size/4)))+(i*10)+10+(size/6), 250-(size/2), size/4, size/2);
	    g.setColor( Color.CYAN );
	    g.fillRect( ((i*(size-(size/4)))+(i*10)+10+(size-(size/4)))-(size/3), (250-(size/2))-(size/3), size/4, size/4);
    }
    
    //Stoplicht
    g.setColor( Color.BLACK );
    g.fillRoundRect( stoplichtMidden - 15, 125, 30, 80, 5, 5 );
    g.fillRect( stoplichtMidden - 3, 205, 6, 60 );
    if( model.isRood() )
      g.setColor( Color.RED );
    else 
      g.setColor( Color.LIGHT_GRAY );
      g.fillOval( stoplichtMidden - 10, 130, 20, 20 );
    if( model.isOranje() )
      g.setColor( Color.ORANGE );
    else
      g.setColor( Color.LIGHT_GRAY );
      g.fillOval( stoplichtMidden - 10, 155, 20, 20 );
    if( model.isGroen() )
      g.setColor( Color.GREEN );
    else
      g.setColor( Color.LIGHT_GRAY );
      g.fillOval( stoplichtMidden - 10, 180, 20, 20 );
    
    //Car
    if( x <= xi ){
      g.drawImage(carimage,x,220,null);
    }
    else if( x > xi ){
      g.drawImage(carimagei,x,220,null);
    }
    if( x2 < x2i ){
      g.drawImage(carimage2i,x2,240,null);
    }
    else if( x2 >= x2i ){
      g.drawImage(carimage2,x2,240,null);
    }

	 //Mannetje
	 for( int i=0; i<aantal; i++){    
      animatedGif.paintIcon( this, g, 50+(i*80), 230 );
    }
  }
}

class Bedieningspaneel extends JPanel {
  private Verkeerslicht model;
  private JPanel view;
  private JButton roodKnop, oranjeKnop, groenKnop;
  private JButton groter, kleiner;
  private JButton toeter;
  private JScrollBar carBar, carBar2;
  private JTextField tekstVak;

  // Constructor
  public Bedieningspaneel( Verkeerslicht model, JPanel view ) {
    this.model = model;
    this.view = view;

    roodKnop   = new JButton( "rood" );
    oranjeKnop = new JButton( "oranje" );
    groenKnop  = new JButton( "groen" );

    ActionListener handler = new Handler();
    roodKnop.addActionListener( handler );
    oranjeKnop.addActionListener( handler );
    groenKnop.addActionListener( handler );
    
    add( roodKnop );
    add( oranjeKnop );
    add( groenKnop );
    
    groter = new JButton( "groter" );
    kleiner = new JButton( "kleiner");
    
    ActionListener handler2 = new Handler2();
    groter.addActionListener( handler2 );
    kleiner.addActionListener( handler2 );
    
    add( groter );
    add( kleiner );
    
    toeter = new JButton( "toeter" );
    ActionListener handler3 = new Handler3();
    toeter.addActionListener( handler3 );
    add( toeter );
    
    tekstVak = new JTextField( 10 );
    tekstVak.addActionListener( new Handler4() );
    add( tekstVak );

  

    
    carBar = new JScrollBar( Scrollbar.HORIZONTAL, 732, 0, -145, 800 );
    carBar.setUnitIncrement( 5 );
    AdjustmentListener listener = new Listener();
    carBar.addAdjustmentListener( listener );
    add( carBar );
    
    carBar2 = new JScrollBar( Scrollbar.HORIZONTAL, 0, 0, -145, 800 );
    carBar2.setUnitIncrement( 5 );
    AdjustmentListener listener2 = new Listener2();
    carBar2.addAdjustmentListener( listener2 );
    add( carBar2 );
    
    try {
    	java.applet.AudioClip clip = java.applet.Applet.newAudioClip( new java.net.URL( "http://www.midishrine.com/ostepop/ngc/Mario_Kart_Double_Dash/mario_circuit.mid" ) );
      clip.loop();
    }
    catch( Exception fe ) {
    }    
  }

  class Handler implements ActionListener {
    public void actionPerformed( ActionEvent e ) {
      if( e.getSource() == roodKnop ){
        model.setRood();
        remove( carBar );
        remove( carBar2 );
        Verkeerslichtview.animatedGif = new ImageIcon( "13.gif" );
        try {
        java.applet.AudioClip clip = java.applet.Applet.newAudioClip( new java.net.URL( "http://www.luliart.com/sounds/wav/BUZZER.WAV" ) );
        clip.play();
        }
        catch( Exception fe ) {
        }
      }
      else if( e.getSource() == oranjeKnop ) {
        model.setOranje();
        add( carBar );
        add( carBar2 );
        Verkeerslichtview.animatedGif = new ImageIcon( "18.gif" );
        try {
        java.applet.AudioClip clip = java.applet.Applet.newAudioClip( new java.net.URL( "http://www.xs4all.nl/~jomajiti/stop.wav" ) );
        clip.play();
        }
        catch( Exception fe ) {
        }
      }
      else if( e.getSource() == groenKnop ) {
        model.setGroen();
        add( carBar );
        add( carBar2 );
        Verkeerslichtview.animatedGif = new ImageIcon( "12.gif" );
        try {
        java.applet.AudioClip clip = java.applet.Applet.newAudioClip( new java.net.URL( "http://www.xs4all.nl/~jomajiti/tada.wav" ) );
        clip.play();
        }
        catch( Exception fe ) {
        }
      }
      
      view.repaint();
    }
  }
  
  class Listener implements AdjustmentListener {
    public void adjustmentValueChanged(AdjustmentEvent ae){
        {Verkeerslichtview.xi = Verkeerslichtview.x;}
        Verkeerslichtview.x = ae.getValue();
        view.repaint();
    }
  }
  
  class Listener2 implements AdjustmentListener {
    public void adjustmentValueChanged(AdjustmentEvent ce){
        {Verkeerslichtview.x2i = Verkeerslichtview.x2;}
        Verkeerslichtview.x2 = ce.getValue();
        view.repaint();
    }
  }
  
  class Handler2 implements ActionListener {
    public void actionPerformed( ActionEvent be ) {
	  if( Verkeerslichtview.size < 185 ){
	      if( be.getSource() == groter ){
	        Verkeerslichtview.size += 5;
	        view.repaint();
	      }
	  }
	  if( Verkeerslichtview.size > 75 ){
	      if( be.getSource() == kleiner ) {
	      Verkeerslichtview.size -= 5;
	      view.repaint();
	      }
      }
    }
  }
  
  class Handler3 implements ActionListener {
    public void actionPerformed( ActionEvent de ) {
	    try {
        java.applet.AudioClip clip = java.applet.Applet.newAudioClip( new java.net.URL( "http://www.xs4all.nl/~jomajiti/auto1.wav" ) );
        clip.play();
        }
        catch( Exception fe ) {
        }
	 }
  }
  
  class Handler4 implements ActionListener {
    public void actionPerformed( ActionEvent xe ) {
      String invoer = tekstVak.getText();
      Double aantal = Double.parseDouble( invoer );
      Verkeerslichtview.aantal = aantal;
      tekstVak.setText( "" );
    } 
  }
  
  public void paintComponent( Graphics g ) {
    super.paintComponent( g );

	 g.drawImage(Verkeerslichtview.grass,0,0,null);
  }

}

// Model
class Verkeerslicht {
  private boolean rood, oranje, groen;

  public Verkeerslicht( boolean rood, boolean oranje, boolean groen ) {
    this.rood = rood;
    this.oranje = oranje;
    this.groen = groen;
  }

  public void setRood() {
    reset();
    rood = true;
  }

  public void setOranje() {
    reset();
    oranje = true;
  }

  public void setGroen() {
    reset();
    groen = true;
  }
  
  public void reset() {
    rood   = false;
    oranje = false;
    groen  = false;
  }
  
  public boolean isRood() {
    return rood;
  }

  public boolean isOranje() {
    return oranje;
  }

  public boolean isGroen() {
    return groen;
  }
}
